#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>

struct Edge
{
	int v1;
	int v2;
	double distance;
};

static bool connected[100000] = { false };

int main()
{ 
	std::vector<std::pair<int, int>> coords;
	
	int count;
	
	std::cin >> count;
	
	if (count == 1)  { std::cout << 0 << std::endl; return 0;}
	
	for(int i = 0; i < count; i++)
	{
		int x, y;
		std::cin >> x >> y;
		
		coords.push_back(std::make_pair(x, y));
	}
	
	std::vector<Edge> edges;
	for(int i = 0; i < count; i++)
	{		
		for(int j = i+1; j < count; j++)
		{
			Edge e;
			e.v1 = i;
			e.v2 = j;
			e.distance = abs(coords[i].first - coords[j].first) + abs(coords[i].second - coords[j].second);
			//std::cout << e.distance << std::endl;
			edges.push_back(e);
		}
	}
	
	
	
	std::sort(edges.begin(), edges.end(), [](const Edge &first, const Edge &second){
			return first.distance < second.distance;
	});
	
	for (Edge e : edges){
		std::cout << e.v1 << " " << e.v2 << "distance: " << e.distance <<std::endl;
	}
	

	double distance = 0;
	int vConnectedCount = 2;
	int v1 = 0;
	int v2 = count - 1;

	connected[v1] = true;
	connected[v2] = true;
		
	while (vConnectedCount <= count) {
		std::cout << "distance: " << distance << std::endl;
		
		Edge e1;
		Edge e2;
		int e1i = -1;
		int e2i = -1;
		
		for (int i = 0; i < edges.size(); i++) {
			Edge e = edges[i];
			// Edge connected to v1
			if (e1i < 0 && (e.v1 == v1 || e.v2 == v1)) {
				if (e.v1 == v1) {
					if (connected[e.v2]) continue;
				}
				else {
					if (connected[e.v1]) continue;
				}
				e1 = e;
				e1i = i;
				std::cout << "Edge found between: " << e.v1 << " " << e.v2 << std::endl;
			}
			
			// Edge connected to v2
			else if (e2i < 0 && (e.v1 == v2 || e.v2 == v2)) {
				if (e.v1 == v2) {
					if (connected[e.v2]) continue;
				}
				else {
					if (connected[e.v1]) continue;
				}
				e2 = e;
				e2i = i;
				std::cout << "Edge found between: " << e.v1 << " " << e.v2 << std::endl;
			}
			if (e1i >= 0 && e2i >= 0) break;
		}
		
		if (count - vConnectedCount == 1) {
			std::cout << "Connecting last 2" << std::endl;
			distance += e1.distance + e2.distance;
			break;
		}
		if (count - vConnectedCount == 0) {
			std::cout << "Connecting last 1" << std::endl;
			for (Edge e : edges){
				if ((e.v1 == v1 && e.v2 == v2) || (e.v1 == v2 && e.v2 == v1)){
					distance += e.distance;
					break;
				}
			}
			break;
		}
		
		if (e1.v1 != e2.v1 && e1.v1 != e2.v2 && e1.v2 != e2.v1 && e1.v2 != e2.v2){
			std::cout << e1.v1 << " " << e1.v2 << " " << e2.v1 << " " << e2.v2 << std::endl;
			std::cout << "Connecting both" << std::endl;
			connected[e1.v1] = true;
			connected[e1.v2] = true;
			connected[e2.v1] = true;
			connected[e2.v2] = true;
			if (e1.v1 == v1) v1 = e1.v2;
			else v1 = e1.v1;
			if (e2.v1 == v2) v2 = e2.v2;
			else v2 = e2.v1;
			distance += e1.distance + e2.distance;
			vConnectedCount += 2;
			continue;
		}
		
		if (e1.distance > e2.distance) {
			std::cout << "e1 is longer" << std::endl;
			if (e1.v1 == v1) v1 = e1.v2;
			else v1 = e1.v1;
			connected[v1] = true;
			distance += e1.distance;
			vConnectedCount++;
		}
		else {
			std::cout << "e2 is longer" << std::endl;
			if (e2.v1 == v2) v2 = e2.v2;
			else v2 = e2.v1;
			connected[v2] = true;
			distance += e2.distance;
			vConnectedCount++;
		}
	}
	
	std::cout << distance << std::endl;
	
	return 0;
};
